package main

// sends 0...k-1 on channel out
func Ping(out chan int, k int) {
	for i := 0; i < k; i++ {
		println("ping", i)
		out <- i
	}
}

// receives k integers on channel in
func Pong(in chan int, k int) {
	for i := 0; i < k; i++ {
		<- in
		println(i, "pong")
	}
}

func main() {
	c := make(chan int)
	k := 10
	go Ping(c, k)
	Pong(c, k)
	println("end game")
}


// sends 0...k-1 on channel out
// after each send waits a reply on channel in
func Ping(in chan int, out chan int, k int) {
	for i := 0; i < k; i++ {
		println("ping", i)
		out <- i
		<-in
	}
}

// sends 0...k-1 on channel out
// before each send waits a msg on channel in
func Pong(in chan int, out chan int, k int) {
	for i := 0; i < k; i++ {
		<-in
		println("pong", i)
		out <- i
	}
}

func main() {
	ping := make(chan int)
	pong := make(chan int)
	k := 10
	go Pong(pong, ping, k)
	Ping(ping, pong, k)
	println("end game")
}
