package main

import "time"
import "math/rand"

const min1, max1, min2, max2 int = 1, 10, 1000, 1015
const tot = (1+max1-min1)+(1+max2-min2)

// objective: show use of select

// returns a channel c where all numbers between min and max will be sent
func Gen(min int, max int) chan int {
	c := make(chan int)
	go Genc(c, min, max)
	return c
}

// sends on channel c all numbers between min and max
func Genc(c chan int, min int, max int) {
	for i := min; i <= max; i++ {
		c <- i
		// random sleep
		time.Sleep(time.Duration(rand.Intn(5e2)) * time.Millisecond)
	}
}

// receives all messages sent on c1 and c2 and prints them on screen
func main() {
	c1 := Gen(min1, max1)
	c2 := Gen(min2, max2)
	i := 0
	for i < tot {
		select {
		case m := <-c2:
			println("got", m, "from c2")
			i++
		case n := <-c1:
			println("got", n, "from c1")
			i++
		default:
			println("Waiting...")
			// random sleep
			time.Sleep(time.Duration(rand.Intn(1e2)) * time.Millisecond)
		}
	}
	println("Bye!")
}
